--Easy Converter
--By Xeroo 08/03/2010
--BASED ON TipCalc by DanTheLegoMan
imgPlayer = {};
calcImg = image.load("res/bg.png");
--State 0 = Enter Amount
--State 1 = Select Conversion
state = 0;
value = -1;
decimals = -1;
zeros = 0;
chars = 0;
maxchars = 12;
tip = -1;
split = -1;

-- button define
btnOne 		= {name0="1",	name1="l to gal",		x=88,	y=152,	width=60,	height=32,	func=gotOne}
btnTwo 		= {name0="2",	name1="gal to l",		x=174,	y=152,	width=60,	height=32,	func=gotTwo}
btnThree 	= {name0="3",	name1="inch to cm",			x=262,	y=152,	width=60,	height=32,	func=gotThree}
btnFour 	= {name0="4",	name1="ft to m",		x=88,	y=106,	width=60,	height=32,	func=gotFour}
btnFive 	= {name0="5",	name1="lb to kg",		x=174,	y=106,	width=60,	height=32,	func=gotFive}
btnSix 		= {name0="6",	name1="mph to kmh",	x=262,	y=106,	width=60,	height=32,	func=gotSix}
btnSeven 	= {name0="7",	name1="m to ft",		x=88,	y=60,	width=60,	height=32,	func=gotSeven}
btnEight 	= {name0="8",	name1="kg to lb",		x=174,	y=60,	width=60,	height=32,	func=gotEight}
btnNine 	= {name0="9",	name1="kmh to mph",	x=262,	y=60,	width=60,	height=32,	func=gotNine}
btnZero 	= {name0="0",	name1="cm to inch",			x=88,	y=200,	width=60,	height=32,	func=gotZero}
btnDot 		= {name0=".",	name1="",			x=174,	y=200,	width=60,	height=32,	func=gotDot}
btnDone 	= {name0="Done",name1="Done",		x=262,	y=200,	width=60,	height=32,	func=gotValue}
btnReset	= {name0="C",	name1="C",			x=347,	y=15,	width=60,	height=32,	func=gotReset}

buttons = { btnOne, btnTwo, btnThree, btnFour, btnFive, btnSix, btnSeven, btnEight, btnNine, btnZero, btnDot, btnDone, btnReset };

function reset()
	state = 0;
	chars = 0;
	value = -1;
	decimals = -1;
	tip = -1;
	zeros = 0;
	split = -1;
end

function enterAmount(i)
	if (i>=1) and (i<=9) and (chars < maxchars) then	--Buttons '1' to '9'
		if (decimals == -1) then
			if (value == -1) then
				value = i
			else
				value = i + value * 10
			end
		else
			decimals = decimals + 1;
			zeros = 0;
			value = value + i * math.pow(10, -decimals)
		end
		chars = chars + 1;
	elseif (i == 10) and (chars < maxchars) then		--Button '0'
		if (decimals == -1) then
			if (value == -1) then
				value = 0;
			else
				value = value * 10;
			end
		else
			decimals = decimals + 1;
			zeros = zeros + 1;
		end
		chars = chars + 1;
	elseif (i == 11) then								--Button '.'
		if (decimals == -1) then decimals = 0 end
		if (value == -1) then value = 0 end
	elseif (i == 12) then								--Button 'Done'
		if (value ~= -1) then
			state = 1;
			chars = 0;
		end
	elseif (i == 13) then								--Button 'Reset'
		if (value ~= -1) then
			reset();
			chars = 0;
		end
	end
end

function enterTip(i)
	if (i==7) then --m/ft
		tip = 3.2808;
	elseif (i == 4) then --ft/m
		tip = 0.3048;
	elseif (i == 8) then --kg/lb
		tip = 2.204;
	elseif (i == 5) then --lb/kg
		tip = 0.453;
	elseif (i == 9) then --kmh/mph
		tip = 0.6213;
	elseif (i == 6) then --mph/kmh
		tip = 1.609;
	elseif (i == 1) then --l/gal
		tip = 0.2199;
	elseif (i == 2) then --gal/l
		tip = 4.546;
	elseif (i == 3) then --inch/cm
		tip = 2.54;
	elseif (i == 10) then
		tip = 0.3937;
	elseif (i == 11) then
		tip = 2;
	elseif (i == 13) then								--Button 'Reset'
		if (value ~= -1) then
			reset();
			chars = 0;
		end
	elseif (i == 12) then
		if (tip ~= -1) then
			reset();
		end
	end
end

function checkTouch(x,y)
	for i=1, table.getn(buttons) do
		if ((x >= buttons[i].x) and (x <= buttons[i].x+buttons[i].width) and
			(y >= buttons[i].y) and (y <= buttons[i].y+buttons[i].height)) then
			if (state == 0) then
				enterAmount(i)
			elseif (state == 1) then
				enterTip(i)
			elseif (state == 3) and (i == 12) then
				reset();
			end
			break
		end
	end
end

function drawScreen()
	calcImg:draw(0,0)
	ots = text.size(24)
	otc = text.color(color.new(0,0,0))
	if (state == 0) then
		if (value == -1) then
			display = "_"
		else
			int = math.floor(value);
			if ((value - int) ~= 0) then
				display = value;
			else
				display = ""..int
				if (zeros > 0) or (decimals ~= -1) then
					display = display.."."
				end
			end
			if (zeros > 0) then
				for i=1,zeros do
					display = display.."0";
				end
			end
		end
	elseif (state == 1) then
		if (tip == -1) then
			display = "Select Conversion"
		else
			total = (value) * tip;
			display = ""..total
		end
	end
	text.draw(90,10,display,"right",320);
	text.size(20);
	text.color(color.new(255,255,255));
	for i=1, table.getn(buttons) do
		if (state == 0) or ((state == 2) and (i ~= 11)) then
			text.draw(buttons[i].x,buttons[i].y,buttons[i].name0,"center",buttons[i].x+buttons[i].width);
		elseif (state == 1) then
			text.draw(buttons[i].x,buttons[i].y,buttons[i].name1,"center",buttons[i].x+buttons[i].width);
		end
	end
	screen.update();
	text.size(ots);
	text.color(otc);
end

while 1 do
	if control.read()==1 then
		if control.isTouch()==1 then
			if touch.up()==1 or touch.click()== 1 then
				x,y = touch.pos()
				checkTouch(x,y);
			end
		elseif control.isButton()==1 then
			if button.click()== 1 then
				break;
			end
		end
	end
	drawScreen();
	os.sleep(1);
end
